/*-------------------------------------------------------------------------
 *
 * pgsql_fdw.h
 *		  foreign-data wrapper for remote PostgreSQL servers.
 *
 * Copyright (c) 2011, PostgreSQL Global Development Group
 *
 * IDENTIFICATION
 *		  pgsql_fdw/pgsql_fdw.h
 *
 *-------------------------------------------------------------------------
 */

#ifndef PGSQL_FDW_H
#define PGSQL_FDW_H

#include "postgres.h"
#include "nodes/relation.h"

/* in option.c */
const char *GetFdwOption(Oid relid, const char *optname);
int ExtractConnectionOptions(List *defelems,
							 const char **keywords,
							 const char **values);

/* in deparse.c */
char *deparseSql(Oid relid, PlannerInfo *root, RelOptInfo *baserel);
char *deparseJoinSql(Oid serverid,
					 PlannerInfo *root,
					 RelOptInfo *joinrel,
					 JoinType jointype,
					 SpecialJoinInfo *sjinfo,
					 Path *outer_path,
					 Path *inner_path,
					 List *restrict_clauses,
					 List *pathkeys);

/* in ruleutils.c */
/*
 * XXX should be moved into src/backend/utils/adt/ruleutils.c in 9.2
 */
List * deparse_context_for_rangetblentries(List *rtable);
char * deparse_expression_pg(Node *expr, List *dpcontext,
							 bool forceprefix, bool showimplicit);

#endif /* PGSQL_FDW_H */
